# atelier-webscraping

This tutorial is inspired by the following two presentations, thanks a lot to their authors : 

- https://pythonds.linogaliana.fr/content/manipulation/04a_webscraping_TP.html#la-zone-grise-de-la-l%C3%A9galit%C3%A9-du-webscraping
- https://github.com/InseeFrLab/formation-webscraping


Le diaporama de l'atelier est disponible ici : https://methodo-ipc.pages.lab.sspcloud.fr/atelier-webscraping

Il ne faut pas nommer de fichier comme un nom de module python qu'on importe. (ex pas de selenium.py)

## Selenium
Pour la partie sur sélénium 

### Sur un poste personnel


il faut avoir un environnement où un navigateur est installé.

Dans ce cas il faut 
- télécharger un driver pour notre navigateur.
(regarder celui correspondant à votre navigateur dans la doc https://pypi.org/project/selenium/)
- choisir un .zip et le télécharger
- le dezipper
- rajouter un lien dans le path vers le .exe du driver
(sur windows, Rechercher, modifier les variables d'environnement pour votre compte, modifier la variable path en rajoutant une valeur )

et voilà. On peut ensuite tester, par exemple pour firefox dans un fichier python :

```
from selenium import webdriver
# ouvre un nouveau firefox et visite la page voulue
browser = webdriver.Firefox()
browser.get('http://selenium.dev/')
```


## sur l'environnement du SSPCloud : 

il faudra lancer préalablement les commandes suivante (dans un terminal du service) pour télécharger un navigateur chrome lancable en mode "headless":

```
wget https://dl.google.com/linux/direct/google-chrome-stable_current_amd64.deb -O /tmp/chrome.deb
sudo apt-get update
sudo apt-get install -y /tmp/chrome.deb
```

Il faudra ensuite lancer une fois les commandes ci dessous pour installer le driver:
```
pip install chromedriver-autoinstaller selenium
import chromedriver_autoinstaller
chromedriver_autoinstaller.install()
```

Le navigateur proposé est lancable en headless dans notre environnement, il ne faudra pas oublier de passer dans les 
options du driver "--headless" avant d'ouvrir le navigateur avec le code 
```
from selenium import webdriver
chrome_options = webdriver.ChromeOptions()
chrome_options.add_argument('--headless')
browser = webdriver.Chrome()
```

Attention, parfois plusieurs versions de python sont installées dans l'environnement, vérifier que c'est bien la même version qui est utilisée pour installer les packages avec pip que pour lancer les codes.