
## le language python

des tutoriels :


https://wiki.python.org/moin/BeginnersGuide

https://devguide.python.org/



---

## Les types de données

- Nombres (int, float, complex)
- Booléens
- List, Set
- Dictionnaire
- Séquence (String, List, Tuple)

---

## Les instructions & opérateurs logiques

- if elif else

```python
if (nombre>0):
    print(' strictement positif')
elif (nombre ==0):
    print('nul')
else:
    print('strictement negatif')
```
on voit que l'indentation est importante en python
- and et or pour combiner des conditions

---

## Les boucles

- for : parcourir les éléments d'une liste.
- la fonction range peut aider : range(start, stop, step) renvoie la séquence correspondante

```python
#exemple 1
nombre_elements=0
for e in liste:
    nombre_elements++
    # compte le nombre d'éléments

#exemple 2
x = range(3, 6)
for n in x:
    print(n) 
    # renvoie 3 4 5, par défaut step vaut 1

i=3
while i<6:
    print(i)
    i++
    # renvoie 3 4 5 

```



---


## des fonctions

- print
- conversion 
```python
texte=str(10)
#'10'
```


---

## creer des fonctions afin de découper son code:
creer : 
```python
def factorielle(n):
    resultat=1
    for i in range(n):
        resultat=resultat*n
    return resultat

```
appel:
```python
factorielle(5)
#renvoi 120
```

l'usage est d'utiliser le snake_case pour le nom des
attributs et méthodes en python

---

## La notion de librairie 

- ensemble de code (objets, fonctions, ...) utile pour simplifier le code.
- peut aussi être appelé bibliothèque, package ou module.
- python possède de nombreuse librairies
- https://openclassrooms.com/fr/courses/7771531-decouvrez-les-librairies-python-pour-la-data-science

---

## comment installer un module et les bonnes pratiques

- pip est l'installeur de package
https://docs.python.org/fr/dev/installing/index.html

```python
pip install my_library
```

- créer un fichier .txt avec la liste des dépendances

```python
pip install requirement.txt
```


---

## comment importer un module ou package

- soit importer tout le module (avec alias): 

```python
import requests as rq
```
- soit importer tout le module : 
```python
from  requests import 
```

---




## La notion d'objets : des attributs et des méthodes

- Comme Java et d'autres langage, Python peut être utilisé pour la programmation orientée objet.
- Le principe est de simplifier la lecture du code en adoptant une structure proche de l'humain. 
- exemple : un objet voiture avec des attributs roue, volant et des méthodes comme rouler, changer de vitesse...


---



## Le module pandas

https://pandas.pydata.org/

- permet de structurer les données (Dataframe)
- utile pour organiser les données collectées
- pourra permettre de lire et écrire des fichiers csv, xlsx, parquet..

---

### des exemples 
```python
# la moyenne par matiere d'une classe

noms_colonnes=['Matiere','Moyenne']
moyennes = [['Maths',9],['Anglais',7]]
df=pandas.DataFrame(moyennes,columns = noms_colonnes)

#   Matiere  Moyenne
#0    Maths        9
#1  Anglais        7

#on peut sauvegarder en csv (d'autres formats sont possibles)
df.to_csv('resultat.csv')

# on peut filtrer 
df[df['Moyenne']> 5]
```

---

## Les expression régulières

le package re : https://docs.python.org/fr/3/library/re.html

- des caractères spéciaux servant de joker représentant des chaines de caractères particulières.
- ex : + , *, ?, \w, \s...
- des fonctions search, match, split permettant de vérifier des conditions.
- des objets : pattern par exemple pour définir un patron à vérifier sur des string.


---

## match, search and fullmatch

- re.match() cherche une correspondance au début de la chaîne
- re.search() cherche une correspondance n'importe où dans la chaîne 
- re.fullmatch() cherche une correspondance entre la chaîne entière et le paramètre à comparer

---

## findall

- cherche une correspondance n'importe où dans la chaîne de caractères
- findall récupère toutes les occurences.

```python
# exemple
re.findall(r'\d+', texte)[0]
# renvoie le premier nombre trouvé dans le texte.
```
- restera la question des unités, des séparateurs (décimales, milliers...)

---

## split


- split construit une liste de chaîne de caractères (avant la condition, après la condition etc.)
ex : 
```python
re.split(r'\W+', 'Words, words, words.')
['Words', 'words', 'words', '']
```

- les variables et les valeurs peuvent être séparé par des caractères identifiables dans le contenu d'une page web (par ex "nom : Michel ; prénom : Louise".)