# Le web

---

## Comprendre la nature d’une page web
- Un site Internet est constitué de diverses pages Web.
   - Celles-ci sont le produit de fichiers appelés codes source des pages.
- Les 3 langages principaux pour les coder sont :
   - HTML : pour composer la structure des pages via un système de balises
   - CSS : des feuilles de style pour décrire la présentation de pages HTML
   - JavaScript : pour tout ce qui est relatif à l’interactivité d’un site (ex : boutons)



---


## Le HTML les élements :

- Sur une page web, vous trouverez toujours à coup sûr des éléments comme < head>, < title>, etc. 
- Il s’agit des codes qui vous permettent de structurer le contenu d’une page HTML et qui s’appellent des balises.
- La plupart des balises vont par paires, avec une balise ouvrante et une balise fermante (par exemple < p> et < />).

---

## Parent et enfant

Dans le cadre du langage HTML, les termes de parent (parent) et enfant (child) servent à désigner des élements emboîtés les uns dans les autres. Dans la construction suivante, par exemple :
```
<div> 
    <p>
       bla,bla
    </p>
</div>
```

---

Sur la page web donnera :
<div> 
<p>
   bla,bla
</p>
</div> 
On dira que 

- l’élément < div> est le parent de l’élément < p>
- l’élément < p> est l’enfant de l’élément < div>.

---

La liste des éléments :

 https://developer.mozilla.org/fr/docs/Web/HTML/Element

- < p> : paragraphe
- < div>
- elements pour les tableaux
- titres de différents niveaux (< h1>, < h2>)
- < > (début d'une partie)
- </ > indique la fin de cette partie

---

<table>
<caption> Elements du tableau </caption>
   <tr>
      <th>Balise</th>
      <th>Description</th>
   </tr>
   <tr>
      <td>< table> </td>
      <td>Tableau</td>
   </tr>
   <tr>
      <td>< caption>  </td>
      <td>Titre du tableau</td>
   </tr>
   <tr>
      <td>< tr> </td>
      <td>	Ligne de tableau</td>
   </tr>
   <tr>
      <td>	
< td> 	</td>
      <td>Cellule</td>
   </tr>
     <tr>
      <td>< thead>  </td>
      <td>Section de l’en-tête du tableau</td>
   </tr>
     <tr>
      <td>< tbody> </td>
      <td>Section du corps du tableau</td>
   </tr>
   <tr>
      <td>< tfoot> </td>
      <td>Section du pied du tableau</td>
   </tr>
</table>

---

## Le HTML exemple les tableaux :

Le code HTML du tableau suivant
```HTML
<table>
<caption> Le Titre de mon tableau </caption>
   <tr>
      <th>Prénom</th>
      <th>Nom</th>
      <th>Profession</th>
   </tr>
   <tr>
      <td>Mister</td>
      <td>Pink</td>
      <td>Gangster</td>
   </tr>
</table>
```

---

Donnera dans le navigateur :
<table>
<caption> Le Titre de mon tableau </caption>

   <tr>
      <th>Prénom</th>
      <th>Nom</th>
      <th>Profession</th>
   </tr>
   <tr>
      <td>Mister</td>
      <td>Pink</td>
      <td>Gangster</td>
   </tr>
</table>


---

Mais pourquoi apprendre ça pour “scraper” ?

- Parce que, pour bien récupérer les informations d’un site internet, il faut pouvoir comprendre sa structure et donc son code HTML.
- Les fonctions Python qui servent au scraping sont principalement construites pour vous permettre de naviguer entre les balises. 
- Avec Python, vous allez en fait reproduire votre comportement manuel de recherche de manière à l’automatiser.




---


Les éléments ont des attributs (utile par la suite pour le repérage) :

https://developer.mozilla.org/fr/docs/Web/HTML/Global_attributes/

- id -> identifiant
- class -> style
- hidden -> element caché ou non
- datatest ou datatest-id -> identifiant servant pour des tests automatisés (selenium, cypress)

---

Exemple : 

```HTML
<div id="blocPrix">
   <span class="barré" id="prixAvantPromo">
   192€
   </span>
   <span id="prix">
   155€
   </span>
</div>
```



---

## Qu'est ce qu'un navigateur

Larousse : `Logiciel client pour l'affichage de pages Web au format HTML, qui permet l'activation de liens hypertextes pour aller de site en site. `

---

## HTTP

- Protocle permettant à un client d'intéroger des serveurs afin 
   - d'obtenir le cotenu des pages.
   - d'envoyer des informations.
- des méthodes (standards à respecter par les développeurs):
   - get : à utiliser pour récupérer des informations
   - post : envoyer des informations
   - put, patch : mettre à jour des données (totalité ou partiellement).
   - delete : supprimer des données
- le client peut être un navigateur, un client python, etc.
- la liaison peut avoir des intermédiaires (proxy par ex)


---

Schéma simpliste du fonctionnement HTTP(pas de pare-feu, passerelle, proxy, DNS..)

<img src="images/http.png" witdh="600px" />

---

## les en têtes (headers)

https://developer.mozilla.org/fr/docs/Web/HTTP/Headers

`Les en-têtes HTTP permettent au client et au serveur de transmettre des informations supplémentaires avec la requête ou la réponse. `
Par exemple des informations sur l'émetteur de la requete (navigateur, taille de fenetre ...)

---

### les paramètres:

- paramètre dans l'url (méthode de type get souvent)
```
search?platform=Windows&category=office
```
- dans le body : sous forme d'objet JSON souvent.
décrit avec clé : attribut
```
{
  "Id": 12345,
  "Customer": "John Smith",
  "Quantity": 1,
  "Price": 10.00
}
```

---

### les outils du navigateur: la console 

(clic droit - inspecter)
Firefox :
<img src="images/inspecteur_firefox.png" witdh="600px" />



---

Edge/Chrome/Chromium :
<img src="images/inspecteur_edge.png" witdh="600px" />

---

## Exercice 01:

Ouvrez votre navigateur sur le site de votre choix:

- Regardez dans quelle balise se situe un texte qui vous intéresse
- Ouvrez l'onglet réseau (rafraichir la page si besoin et identifiez la requete qui a récupéré le contenu de votre page)

---

## les outils de développement du navigateur: réseau

- savoir le type de requête envoyé
- savoir la manière dont sont passés les paramètres

---

## Une session

- Peut être utilisé par un site pour conserver des données lors d'un parcours de plusieurs pages par un utilisateur.
- caractérisée par un identifiant de session
- ces informations sont renvoyés à chaque requête faite par le client

---

## Les cookies

- fichiers textes stockés chez le client
- peuvent être lus/écrits lors des différentes requêtes

---


## les outils de développement du navigateur: stockage/ Application -> stockage

<img src="images/stockage_edge.png" witdh="600px" />

---