### Une plateforme de travail : le [SSP Cloud](https://datalab.sspcloud.fr/home)
<img src="images/macbook_onyxia.png" height="600px" />

---

## Un Datalab pour l'expérimentation et la formation

- Plateforme de datascience dimensionnée pour les usages innovants
- Des technologies modernes qui favorisent la reproductibilité
- Lieu de formation et d'expérimentation
- Ouverte et collaborative

---

### Du libre-service à la mise en production

<img src="images/onyxia_galaxy.png" height="500px" />

---

## Le projet [Onyxia](https://www.onyxia.sh/)

- Un projet open-source pour déployer des plateformes de datascience modernes


<img src="images/onyxia_instances.png" witdh="500px" />

- Le dépôt Github [ici](https://github.com/InseeFrLab/onyxia)

---

## De la formation

- Le [catalogue de formation](https://www.sspcloud.fr/formation) du SSP Cloud
  - Des formations reproductibles
  - Un catalogue contributif
- Innover sur les modes de formation
  - Vers de l'auto-formation tutorée

---

## De l'open-source

- Comptes GitHub institutionnels
  - [InseeFr](https://github.com/InseeFr)
  - [InseeFrLab](https://github.com/InseeFrLab)
- Pourquoi ouvrir ses codes ?
  - Auditabilité des agents publics
  - Meilleure qualité du code et reproductibilité
  - Une vitrine pour l'auteur.e et pour l'INS
- Pour plus d'informations, contacter [innovation@insee.fr](mailto:innovation@insee.fr)

---

## Comment utiliser le [SSP Cloud](https://datalab.sspcloud.fr/home) ?

- Une [documentation](https://docs.sspcloud.fr/onyxia-guide/decouverte-du-datalab) très complète
- Démonstration en direct !

---

## Mise en pratique : se familiariser à BeautifulSoup et Selenium

- Une mise en pratique créée à destination des étudiants de Master de l'[ENSAE Paris](https://www.ensae.fr/)
    + Incluant notamment les Administrateurs de l'INSEE en formation

- Le lien pour accéder au TP de web scraping [__ici__](https://pythonds.linogaliana.fr/content/manipulation/04a_webscraping_TP.html)

---

## Pour aller plus loin

- Un [site](https://pythonds.linogaliana.fr//) dédié à l'utilisation de Python pour la data science
- Créé et entretenu par [Lino Galiana](https://github.com/linogaliana/), data scientist à l'INSEE
