# AUTOMATISATION

---

## Pré-requis

- Accès Internet au sein de l'INS avec un proxy bien configuré si existant
- Les sites scrapés doivent être dans l'allow-list et ne doivent pas avoir déjà bloqué l'adresse IP

---

## Automatiser et industrialiser les processus de scraping

- En raison des efforts des sites contre le scraping (ex : format des sites changeant régulièrement, blocage des adresses IP),
    + Limiter les interactions humaines est quasiment impossible
    + Industrialiser les processus nécessite des révisions régulières
- Automatiser les méthodes peut reposer sur un [cronjob](https://kubernetes.io/docs/concepts/workloads/controllers/cron-jobs/) ou autre orchestrateur

---

## Utiliser l'environnement SSPCloud & les technologies disponibles.

par exemple:
- Kaniko, Docker & Kubernetes pour décrire une image avec l'environnement, le code à lancer
et avoir un conteneur ou lancer le code.
- Gitlab CI pour paramétrer le dépot git et automatiser la création des éléments ci dessus.
- Orchestrer

---

## Stocker les données


- Les données brutes (ex : les pages web) pourraient être stockées dans une base `NoSQL` et traitées ensuite.
    - Les codes `HTML` peuvent par exemple être stockés dans une base `MongoDB`.
- Problèmes méthodologiques courants :
    - __Différencier le stock du flux__ : la page web que je viens de scraper est-elle nouvelle ou est-ce la même que celle d’hier ?
    - __Dédoublonner le contenu__ lorsque par exemple le scraping se fait sur plusieurs sites dont le contenu peut s'intersecter.

---

## Nettoyer les données

Les données collectées sont souvent brutes et necessitent une étape de nettoyage assez conséquente
- extraire les noms de variables et uniformiser.
- uniformiser et nettoyer les valeurs de variables.
Dissocier les étapes de collecte et de nettoyage peut permettre d'assurer une continuité dans les données.
    - en cas de léger changement du site, la collecte ne serait pas arrêtée et la mise à jour du code de nettoyage pourrait être ultérieure.

---

## Exploiter les données

Définir une méthodologie appropriée à l'exploitation des données et la mettre en oeuvre.